package com.fidufosyga.rules;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Properties;

import com.fidufosyga.context.Context;
import com.fidufosyga.rules.util.ValidarFecha;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 *
 * @author Julian
 */
public class ValidarEntidadesContributivoHomologadaTraslados extends AbstractRule {

    public static final String ENTIDADES_HOMOLOGADA = "ENTIDADES_CONTRIBUTIVO_HOMOLOGADA";
    public static final String ENTIDADES1 = "ENTIDADES_CONTRIBUTIVOS";

    String DATE_FORMAT = "dd/MM/yyyy";

    SimpleDateFormat sdf;

    public ValidarEntidadesContributivoHomologadaTraslados() {
        sdf = new SimpleDateFormat(DATE_FORMAT);
        sdf.setLenient(false);
    }

    public boolean performValidation(String field, String registro[],
            String nombreArchivo) {

        String campoDependienteTraslado = (String) (getParams()[0]);
        int campoDepTraslado = Integer.parseInt(campoDependienteTraslado);
        String trasladoDependiente = registro[campoDepTraslado];
        String trasladoDependienteOriginal = "3,4";

        String tipoTraslado = (String) getParams()[1];

        String campoDependienteFecha = (String) getParams()[2];
        int campoDepFecha = Integer.parseInt(campoDependienteFecha);

        String fechaOtra = (String) getParams()[3];
        String fechaDependiente = registro[campoDepFecha];

        //Fecha de Afiliación
        if (fechaDependiente.length() == 0) {
            return true;
        }

        if (fechaDependiente.length() != 10 || fechaOtra.length() != 10) {
            return false;
        }

        if (!ValidarFecha.esFecha(fechaDependiente)) {
            return false;
        }
        Date dateCampo = null;
        Date dateOtra = null;
        try {
            dateCampo = sdf.parse(fechaDependiente);
            dateOtra = sdf.parse(fechaOtra);
        } catch (Exception e) {
            return false;
        }

        //Entidades Contributivo Homologadas
        if (Context.getContext().getAttribute(ENTIDADES_HOMOLOGADA) == null) {
            Properties defaultProps = new Properties();
            FileInputStream in;

            try {

                in = new FileInputStream(System.getProperty("user.dir")
                        + File.separator + "entidades" + File.separator
                        + "entidadesContributivoHomologada.properties");
                defaultProps.load(in);
                in.close();
                Context.getContext().addAttribute(ENTIDADES_HOMOLOGADA, defaultProps);

            } catch (FileNotFoundException e) {

                return false;
            } catch (IOException e) {

                return false;

            }

        }

        //Entidades Contributivo
        if (Context.getContext().getAttribute(ENTIDADES1) == null) {
            Properties defaultProps = new Properties();
            FileInputStream in;

            try {

                in = new FileInputStream(System.getProperty("user.dir")
                        + File.separator + "entidades" + File.separator
                        + "entidadesContributivo.properties");
                defaultProps.load(in);
                in.close();
                Context.getContext().addAttribute(ENTIDADES1, defaultProps);

            } catch (FileNotFoundException e) {

                return false;
            } catch (IOException e) {

                return false;

            }

        }

        //Validación
        if (((Properties) Context.getContext().getAttribute(ENTIDADES_HOMOLOGADA))
                .getProperty(field) != null) {
            if (tipoTraslado.contains(trasladoDependiente)) {

                if (dateCampo.before(dateOtra)) {
                    return true;
                } else {

                    return false;
                }
            }
        }
        if (((Properties) Context.getContext().getAttribute(ENTIDADES1))
                .getProperty(field) != null) {

            if (trasladoDependienteOriginal.contains(trasladoDependiente)) {

                if (dateCampo.before(dateOtra)) {
                    return true;
                } else {

                    return false;
                }
            } else {
                return false;
            }

        }
        
       return true;
    }
}
